function Label(parent, x, y, width, align, title, func) {
	this.parent = parent;
	this.x = x;
	this.y = y;
	this.width = width;
	this.align = align;
	this.title = title;
	this.func = func;
	this.__construct();
}

Label.prototype = {
	__construct : function() {
		var parpos = findPos(this.parent);
		
		this.div = document.createElement("div");
		this.tn = document.createTextNode(this.title);
		this.div.appendChild(this.tn);
		this.div.style.left = (this.x + parpos[0]) + "px";
		this.div.style.top = (this.y + parpos[1]) + "px";
		
		switch(this.align) {
			case 0: this.div.align = "left"; break;
			case 1: this.div.align = "center"; break;
			case 2: this.div.align = "right"; break;
		}
		
		if(this.width !== undefined && this.width !== null && this.width > 0) {
			this.div.style.width = this.width + "px";
		}
		
		this.div.style.position = "absolute";
		//this.div.style.border = "1px solid red";
		
		this.parent.appendChild(this.div);
	},
	
	Refresh : function(data) {
		this.tn.nodeValue = this.func(data);
	}
};

function SparklineLabel(parent, x, y, width, height, func) {
	this.parent = parent;
	this.x = x;
	this.y = y;
	this.width = width;
	this.height = height;
	this.func = func;
	this.__construct();
}

SparklineLabel.prototype = {
	__construct : function() {
		var parpos = findPos(this.parent);
		
		this.canvas = document.createElement("canvas");
		this.canvas.width = this.width;
		this.canvas.height = this.height;
		this.canvas.style.position = "absolute";
		this.canvas.style.left = (this.x + parpos[0]) + "px";
		this.canvas.style.top = (this.y + parpos[1]) + "px";
		//this.canvas.id = "sll" + (new Date().getTime()+ Math.random());
		this.parent.appendChild(this.canvas);
		
		var data2 = [0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1];
		/*var opts = {"background":"#FFFFFF","stroke":"#444444","top_padding":1,"bottom_padding":1,"left_padding":1,"right_padding":1};
		this.sl = new Sparkline(this.canvas.id, data2, opts);
		this.sl.draw();*/
		
		var ctx = this.canvas.getContext("2d");
		ctx.lineWidth = 0.75;
		this.sl = new sparkline(ctx, data2, null, 0, 0, this.width, this.height);
		this.sl.draw();

	},
	
	Refresh : function(data) {
		var ctx = this.canvas.getContext("2d");
		ctx.clearRect(0,0, this.width, this.height);
		this.sl.data = this.func(data);
		this.sl.draw();
	}
}




function TSparklineLabel(parent, x, y, width, height, func) {
	this.parent = parent;
	this.x = x;
	this.y = y;
	this.width = width;
	this.height = height;
	this.func = func;
	this.__construct();
}

TSparklineLabel.prototype = {
	__construct : function() {
		var parpos = findPos(this.parent);
		
		this.canvas = document.createElement("canvas");
		this.canvas.width = this.width;
		this.canvas.height = this.height;
		this.canvas.style.position = "absolute";
		this.canvas.style.left = (this.x + parpos[0]) + "px";
		this.canvas.style.top = (this.y + parpos[1]) + "px";
		//this.canvas.id = "sll" + (new Date().getTime()+ Math.random());
		this.parent.appendChild(this.canvas);
		
		var data2 = [];
		/*var opts = {"background":"#FFFFFF","stroke":"#444444","top_padding":1,"bottom_padding":1,"left_padding":1,"right_padding":1};
		this.sl = new Sparkline(this.canvas.id, data2, opts);
		this.sl.draw();*/
		
		var ctx = this.canvas.getContext("2d");
		ctx.lineWidth = 0.75;
		this.sl = new time_sparkline(ctx, data2, null, 0, 0, this.width, this.height);

	},
	
	Refresh : function(data) {
		
		var ctx = this.canvas.getContext("2d");
		ctx.clearRect(0,0, this.width, this.height);
		
		this.sl.add(this.func(data));
		this.sl.draw();
	}
}



function Labels() {
	this.items = []
}
Labels.prototype = {
	Add : function(item) {
		this.items[this.items.length] = item;
	},
	
	Refresh : function(data) {
		for(var i = 0; i < this.items.length; i++) {
			this.items[i].Refresh(data);
		}
		
	}
};